package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Component
public class DataInitializer {
    @Autowired
    private EmployeeRepository repository;

    @PostConstruct
    void postConstruct() {
        repository.saveAll(createEmployees());
    }

    private List<Employee> createEmployees() {
        String[] tasksNames = {"Coding", "Refactoring", "Designing", "Documentation", "Planning",
                "Testing", "Deployment"};
        List<Task> tasks = new ArrayList<>(20);
        for (int i = 0; i < tasksNames.length; i++) {
            tasks.add(Task.create(tasksNames[i], RandomUtil.getName()));
        }
        String[] departments = {"IT", "Sales", "Admin", "Account"};
        List<Employee> employees = new ArrayList<>();
        for (int i = 0; i < 50; i++) {
            employees.add(Employee.create(
                    RandomUtil.getName(),
                    RandomUtil.getAnyOf(departments),
                    Arrays.asList(
                            Integer.toString(RandomUtil.getInt(111111,999999)),
                            Integer.toString(RandomUtil.getInt(111111,999999))),
                    new ArrayList<>(RandomUtil.getSomeOf(2, tasks))));
        }
        return employees;
    }
}