package com.logicbig.example;

import javax.persistence.*;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

@Entity
public class Employee {
    private @Id
    @GeneratedValue
    Long id;
    private String name;
    private String dept;
    @ElementCollection(fetch = FetchType.EAGER)
    private Set<String> phones;
    @ManyToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    private List<Task> tasks;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDept() {
        return dept;
    }

    public void setDept(String dept) {
        this.dept = dept;
    }

    public List<Task> getTasks() {
        return tasks;
    }

    public void setTasks(List<Task> tasks) {
        this.tasks = tasks;
    }

    public Set<String> getPhones() {
        return phones;
    }

    public void setPhones(Set<String> phones) {
        this.phones = phones;
    }

    public static Employee create(String name, String dept, List<String> phones, List<Task> tasks) {
        Employee e = new Employee();
        e.setName(name);
        e.setDept(dept);
        e.setTasks(tasks);
        e.setPhones(new HashSet<>(phones));
        return e;
    }
}